// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.batch;

import fr.ifremer.adagio.core.dao.data.measure.QuantificationMeasurement;
import fr.ifremer.adagio.core.dao.data.operation.FishingOperation;
import fr.ifremer.adagio.core.dao.data.produce.Produce;
import fr.ifremer.adagio.core.dao.data.survey.landing.Landing;
import fr.ifremer.adagio.core.dao.data.survey.sale.Sale;
import fr.ifremer.adagio.core.dao.referential.QualityFlag;
import fr.ifremer.adagio.core.dao.referential.location.Location;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;

/**
 * Capture réalisée au cours d'une opération, et sur laquelle un échantillonnage est réalisé.
 * La capture porte donc l'arbre d''échantillonnage.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class CatchBatch
    extends BatchImpl
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 2425749807010787327L;

    // Generate 6 attributes
    private String synchronizationStatus;

    /**
     * Etat de synchronisation (en cours, terminé, en attente de synchro, supprimé). Seulement
     * visible dans la base locale.
     * @return this.synchronizationStatus String
     */
    public String getSynchronizationStatus()
    {
        return this.synchronizationStatus;
    }

    /**
     * Etat de synchronisation (en cours, terminé, en attente de synchro, supprimé). Seulement
     * visible dans la base locale.
     * @param synchronizationStatusIn String
     */
    public void setSynchronizationStatus(String synchronizationStatusIn)
    {
        this.synchronizationStatus = synchronizationStatusIn;
    }

    private Date controlDate;

    /**
     * 
     * @return this.controlDate Date
     */
    public Date getControlDate()
    {
        return this.controlDate;
    }

    /**
     * 
     * @param controlDateIn Date
     */
    public void setControlDate(Date controlDateIn)
    {
        this.controlDate = controlDateIn;
    }

    private Date validationDate;

    /**
     * 
     * @return this.validationDate Date
     */
    public Date getValidationDate()
    {
        return this.validationDate;
    }

    /**
     * 
     * @param validationDateIn Date
     */
    public void setValidationDate(Date validationDateIn)
    {
        this.validationDate = validationDateIn;
    }

    private Date qualificationDate;

    /**
     * 
     * @return this.qualificationDate Date
     */
    public Date getQualificationDate()
    {
        return this.qualificationDate;
    }

    /**
     * 
     * @param qualificationDateIn Date
     */
    public void setQualificationDate(Date qualificationDateIn)
    {
        this.qualificationDate = qualificationDateIn;
    }

    private String qualificationComments;

    /**
     * 
     * @return this.qualificationComments String
     */
    public String getQualificationComments()
    {
        return this.qualificationComments;
    }

    /**
     * 
     * @param qualificationCommentsIn String
     */
    public void setQualificationComments(String qualificationCommentsIn)
    {
        this.qualificationComments = qualificationCommentsIn;
    }

    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    // Generate 5 associations
    private BatchModel batchModel;

    /**
     * 
     * @return this.batchModel BatchModel
     */
    public BatchModel getBatchModel()
    {
        return this.batchModel;
    }

    /**
     * 
     * @param batchModelIn BatchModel
     */
    public void setBatchModel(BatchModel batchModelIn)
    {
        this.batchModel = batchModelIn;
    }

    private FishingOperation fishingOperation;

    /**
     * Opération de peche à laquelle est rattachée l'arbre d'échantillonnage (optionnel).
     * @return this.fishingOperation FishingOperation
     */
    public FishingOperation getFishingOperation()
    {
        return this.fishingOperation;
    }

    /**
     * Opération de peche à laquelle est rattachée l'arbre d'échantillonnage (optionnel).
     * @param fishingOperationIn FishingOperation
     */
    public void setFishingOperation(FishingOperation fishingOperationIn)
    {
        this.fishingOperation = fishingOperationIn;
    }

    private Sale sale;

    /**
     * Vente à laquelle est rattachée l'arbre d'échantillonnage (optionnel).
     * @return this.sale Sale
     */
    public Sale getSale()
    {
        return this.sale;
    }

    /**
     * Vente à laquelle est rattachée l'arbre d'échantillonnage (optionnel).
     * @param saleIn Sale
     */
    public void setSale(Sale saleIn)
    {
        this.sale = saleIn;
    }

    private Landing landing;

    /**
     * Débarquement auquel est rattaché l'arbre d'échantillonnage (optionnel).
     * @return this.landing Landing
     */
    public Landing getLanding()
    {
        return this.landing;
    }

    /**
     * Débarquement auquel est rattaché l'arbre d'échantillonnage (optionnel).
     * @param landingIn Landing
     */
    public void setLanding(Landing landingIn)
    {
        this.landing = landingIn;
    }

    /**
     * This entity does not have any identifiers
     * but since it extends the <code>BatchImpl</code> class
     * it will simply delegate the call up there.
     *
     * @see Batch#equals(Object)
     */
    @Override
    public boolean equals(Object object)
    {
        return super.equals(object);
    }

    /**
     * This entity does not have any identifiers
     * but since it extends the <code>BatchImpl</code> class
     * it will simply delegate the call up there.
     *
     * @see Batch#hashCode()
     */
    @Override
    public int hashCode()
    {
        return super.hashCode();
    }

    /**
     * Constructs new instances of {@link CatchBatch}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link CatchBatch}.
         * @return new CatchBatchImpl()
         */
        public static CatchBatch newInstance()
        {
            return new CatchBatchImpl();
        }

        /**
         * Constructs a new instance of {@link CatchBatch}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param rankOrder Short
         * @param childBatchsReplication Boolean
         * @param exhaustiveInventory Boolean
         * @param qualityFlag QualityFlag
         * @return newInstance
         */
        public static CatchBatch newInstance(Short rankOrder, Boolean childBatchsReplication, Boolean exhaustiveInventory, QualityFlag qualityFlag)
        {
            final CatchBatch entity = new CatchBatchImpl();
            entity.setRankOrder(rankOrder);
            entity.setChildBatchsReplication(childBatchsReplication);
            entity.setExhaustiveInventory(exhaustiveInventory);
            entity.setQualityFlag(qualityFlag);
            return entity;
        }

        /**
         * Constructs a new instance of {@link CatchBatch}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param rankOrder Short
         * @param subgroupCount Float
         * @param individualCount Integer
         * @param childBatchsReplication Boolean
         * @param exhaustiveInventory Boolean
         * @param comments String
         * @param label String
         * @param remoteId Integer
         * @param location Location
         * @param parentBatch Batch
         * @param childBatchs Collection<Batch>
         * @param batchExhaustiveInventories Collection<BatchExhaustiveInventory>
         * @param qualityFlag QualityFlag
         * @param produces Collection<Produce>
         * @param quantificationMeasurements Collection<QuantificationMeasurement>
         * @param synchronizationStatus String
         * @param controlDate Date
         * @param validationDate Date
         * @param qualificationDate Date
         * @param qualificationComments String
         * @param updateDate Timestamp
         * @param batchModel BatchModel
         * @param fishingOperation FishingOperation
         * @param sale Sale
         * @param landing Landing
         * @return newInstance CatchBatch
         */
        public static CatchBatch newInstance(Short rankOrder, Float subgroupCount, Integer individualCount, Boolean childBatchsReplication, Boolean exhaustiveInventory, String comments, String label, Integer remoteId, Location location, Batch parentBatch, Collection<Batch> childBatchs, Collection<BatchExhaustiveInventory> batchExhaustiveInventories, QualityFlag qualityFlag, Collection<Produce> produces, Collection<QuantificationMeasurement> quantificationMeasurements, String synchronizationStatus, Date controlDate, Date validationDate, Date qualificationDate, String qualificationComments, Timestamp updateDate, BatchModel batchModel, FishingOperation fishingOperation, Sale sale, Landing landing)
        {
            final CatchBatch entity = new CatchBatchImpl();
            entity.setRankOrder(rankOrder);
            entity.setSubgroupCount(subgroupCount);
            entity.setIndividualCount(individualCount);
            entity.setChildBatchsReplication(childBatchsReplication);
            entity.setExhaustiveInventory(exhaustiveInventory);
            entity.setComments(comments);
            entity.setLabel(label);
            entity.setRemoteId(remoteId);
            entity.setLocation(location);
            entity.setParentBatch(parentBatch);
            entity.setChildBatchs(childBatchs);
            entity.setBatchExhaustiveInventories(batchExhaustiveInventories);
            entity.setQualityFlag(qualityFlag);
            entity.setProduces(produces);
            entity.setQuantificationMeasurements(quantificationMeasurements);
            entity.setSynchronizationStatus(synchronizationStatus);
            entity.setControlDate(controlDate);
            entity.setValidationDate(validationDate);
            entity.setQualificationDate(qualificationDate);
            entity.setQualificationComments(qualificationComments);
            entity.setUpdateDate(updateDate);
            entity.setBatchModel(batchModel);
            entity.setFishingOperation(fishingOperation);
            entity.setSale(sale);
            entity.setLanding(landing);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(CatchBatch o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getSynchronizationStatus() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSynchronizationStatus().compareTo(o.getSynchronizationStatus()));
            }
            if (this.getControlDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getControlDate().compareTo(o.getControlDate()));
            }
            if (this.getValidationDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getValidationDate().compareTo(o.getValidationDate()));
            }
            if (this.getQualificationDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getQualificationDate().compareTo(o.getQualificationDate()));
            }
            if (this.getQualificationComments() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getQualificationComments().compareTo(o.getQualificationComments()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// CatchBatch.java merge-point

  protected java.util.Map<Integer, SortingBatch> sortingBatchById = new java.util.HashMap<Integer, SortingBatch>();

  public java.util.Map<Integer, SortingBatch> getSortingBatchById() {
    return sortingBatchById;
  }

  public void setSortingBatchById(java.util.Map<Integer, SortingBatch> sortingBatchById) {
    this.sortingBatchById = sortingBatchById;
  } 
  
  public void putSortingBatchById(Integer sortingBatchId, SortingBatch sortingBatch) {
    this.sortingBatchById.put(sortingBatchId,sortingBatch);
  }
}